package org.silverpeas.mobile.shared.services.rest;

import static org.fusesource.restygwt.client.AbstractJsonEncoderDecoder.*;

public class ServiceTickets_Generated_RestServiceProxy_ implements org.silverpeas.mobile.shared.services.rest.ServiceTickets, org.fusesource.restygwt.client.RestServiceProxy {
  private org.fusesource.restygwt.client.Resource resource = null;
  
  public void setResource(org.fusesource.restygwt.client.Resource resource) {
    this.resource = resource;
  }
  public org.fusesource.restygwt.client.Resource getResource() {
    if (this.resource == null) {
      String serviceRoot = org.fusesource.restygwt.client.Defaults.getServiceRoot();
      this.resource = new org.fusesource.restygwt.client.Resource(serviceRoot).resolve("/mytickets");
    }
    return this.resource;
  }
  private org.fusesource.restygwt.client.Dispatcher dispatcher = null;
  
  public void setDispatcher(org.fusesource.restygwt.client.Dispatcher dispatcher) {
    this.dispatcher = dispatcher;
  }
  
  public org.fusesource.restygwt.client.Dispatcher getDispatcher() {
    return this.dispatcher;
  }
  public void createTicket(java.lang.String componentId, org.silverpeas.mobile.shared.dto.tickets.TicketDTO dto, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.tickets.TicketDTO> callback) {
    final java.lang.String final_componentId = componentId;
    final org.silverpeas.mobile.shared.dto.tickets.TicketDTO final_dto = dto;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(componentId== null? null : com.google.gwt.http.client.URL.encodePathSegment(componentId))+"/")
    .post();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    __method.json(org.silverpeas.mobile.shared.dto.tickets.TicketDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(dto));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.tickets.TicketDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.tickets.TicketDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.tickets.TicketDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getMyTickets(java.lang.String page, org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.tickets.TicketDTO>> callback) {
    final java.lang.String final_page = page;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .addQueryParam("page", page)
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.tickets.TicketDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.tickets.TicketDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.tickets.TicketDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
}
